Subject: bug#21148: 25.0.50; Huge problems with case-insensitive search

From: Artur Malabarba <[email-masked]>
Date: Wed, 29 Jul 2015 00:15:36 +0100

Marking this as fixed, it has been reported to fuzzy-el:
https://github.com/auto-complete/fuzzy-el/issues/8

For future, the problem here is that there are some search packages
which set the `isearch-search-fun-function' to their own
(poorly-written) function. In this case (and on longlines-mode) the
issue is that the function does the following check:

(cond (isearch-word
          (if isearch-forward 'word-search-forward 'word-search-backward))
         ...)

This assumes that `isearch-word' only ever has a boolean meaning, but
it's been a while now that this variable can also hold a function.
That's how symbol-isearch is implemented, in fact.
The reason these problems weren't reported before, is that the default
value of isearch-word was still nil up until now, but enabling
char-fold by default changed the default value to a function.